# RegisterBackend

## 1. API Description

This API (RegisterBackend) is used to create a backend server (vm or bmc instance) and add it to a load balance listener.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type                                                                                   | Description                                                                                                                               |
| -------------- | -------- | -------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------- |
| listenerId     | Yes      | String                                                                                 | The listener ID.                                                                                                                          |
| backendName    | Yes      | String                                                                                 | <p>Backend server name.</p><p>This parameter can contain up to 64 characters. Only letters, numbers, - and periods (.) are supported.</p> |
| instanceId     | Yes      | String                                                                                 | Bare metal or Virtual machine instance ID.                                                                                                |
| clientToken    | Yes      | String                                                                                 | Used to ensure the idempotency of the request.                                                                                            |
| instanceType   | No       | [InstanceProductType](/api-reference/compute/bmc/datastructure.md#instanceproducttype) | <p>Instance type.</p><p>Default value: BM</p>                                                                                             |
| portList       | No       | Array of Integer                                                                       | Port list.                                                                                                                                |
| weight         | No       | Integer                                                                                | <p>Weight of the instance.</p><p>Value range: \[1, 100]</p>                                                                               |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| backendId      | String | Backend server ID.                                                                                                    |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Add a bare metal instance as a backend server to a load balance listener.**

```json
POST /api/v2/bmc HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: RegisterBackend
<Common Request Params>

Request:
{
  "listenerId": "xxxx",
  "backendName": "xxxx",
  "portList": [80],
  "clientToken": "xxxx",
  "weight": 100,
  "instanceId": "xxxx"
}

Response:
{
  "requestId": "TEEFDCA5B-76FB-4E91-A18E-DF7F5D2CE41F",
  "response": {
    "requestId": "TEEFDCA5B-76FB-4E91-A18E-DF7F5D2CE41F",
    "backendId": "xxxx"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.console.zenlayer.com/api-reference/compute/bmc/load-balancing/registerbackend.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
